/**
 * @file
 * JavaScript integration between EChart.js and Drupal.
 */
(function (Drupal, once) {
  'use strict';

  Drupal.behaviors.chartsECharts = {
    attach(context) {

      once('charts-echarts-init', 'body', context).forEach(function (element) {
        let contents = new Drupal.Charts.Contents();
        let charts = [];
        const elements = once('charts-echarts-chart', '.charts-echarts', context);

        elements.forEach(function (element, index) {
          let chart = contents.getData(element.id);
          let options = chart['options'];
          element.style.height = options.height + options.height_units;
          options.height = 'auto';
          let myChart = echarts.init(element, null, {renderer: 'svg'});
          if (options && typeof options === 'object') {
            myChart.setOption(options);
          }
          if (element.nextElementSibling && element.nextElementSibling.hasAttribute('data-charts-debug-container')) {
            element.nextElementSibling.querySelector('code').innerText = JSON.stringify(chart, null, ' ');
          }
          charts.push(myChart);
        });

        window.onresize = function () {
          charts.forEach(function (chart) {
            chart.resize();
          });
        }
      });
    }
  };
}(Drupal, once));
